public class LeakStack<T> {

    private int size;
    private T[] array;

    public LeakStack(int capacity) {
        array = (T[]) new Object[capacity];
    }

    public void push(T item) {
        if (isFull()) {
            throw new RuntimeException("overflow!");
        }
        array[size++] = item;

    }

    public T pop() {
        if (isEmpty())
            throw new RuntimeException("underflow!");
        T item = array[--size];
        System.out.println(array[size] + " was removed from stack");
        //uncomment following line to fix the memory leak
        array[size] = null;
        return item;
    }

    public boolean isEmpty() {
        return size == 0;
    }

    public int size() {
        return size;
    }


    public boolean isFull() {
        return size == array.length;
    }

}
